#include	"stdThread.h"

#ifdef _MSC_VER			// WindowŝƂ
#define DISABLE_C4996   __pragma(warning(push)) __pragma(warning(disable:4996))
#define ENABLE_C4996    __pragma(warning(pop))
#else					// Linux̂Ƃ
#define DISABLE_C4996
#define ENABLE_C4996
#endif

#define	MAXPENDING		(5)		// ڑobNO
#define	RCVBUFSIZE		(1024)	// ɓǂލőMTCY
#define MAX_SOCKET_NUM	(20)	// ҋ@p\Pbg̍ő吔

// ֐̐錾
BOOL CreateAndBindSocket(WORD wPort);
BOOL DestroySocket(SOCKET &fd);
BOOL DoListen();
BOOL DoAccept();
BOOL DoRecv();
void Stop();
BOOL CheckKey();

// ϐ̐錾
SOCKET	m_fdServer[MAX_SOCKET_NUM];			// ҋ@p\Pbg
int		m_iSockCount;						// ҋ@\Pbg̐
SOCKET	m_fdClient;							// NCAgƂ̒ʐMp\Pbg

int main(int argc, char *argv[])
{
	int		iRet = -1;
	int		ii;

	// Np[^`FbN
	if (argc != 2)
	{
		fprintf(stderr, "Usage:  %s <Server Port>\n", argv[0]);
		goto L_END;
	}

	// ϐ̏
	for (ii = 0; ii < MAX_SOCKET_NUM; ++ii)
		m_fdServer[ii] = INVALID_SOCKET;
	m_fdClient = INVALID_SOCKET;

	// ҋ@p\Pbg̍쐬ƃoCh
	if (CreateAndBindSocket((WORD)atol(argv[1])) == FALSE)
		goto L_END;
	// ڑҋ@Ԃɂ
	if (DoListen() == FALSE)
		goto L_END;
	// ڑvɑ΂ĐڑԂɂ
	if (DoAccept() == FALSE)
		goto L_END;
	// M̎s
	if (DoRecv() == FALSE)
		goto L_END;

	iRet = 0;
L_END:
	Stop();
	return(iRet);
}

//----------------------------------------------
// function
//    ҋ@p\Pbg̍쐬bind̎{
// parameter
//    WORD	wPort	[in]|[gԍ
// return
//    TRUE/FALSE
//----------------------------------------------
BOOL CreateAndBindSocket(WORD wPort)
{
	BOOL	fRet = TRUE;
	struct addrinfo	hints, *pres = NULL, *pTemp = NULL;
	char	szPort[NI_MAXSERV];
	int 	on;

	fprintf(stderr, "CreateAndBindSocket()\n");

	m_iSockCount = 0;
	// Xg[^őҋ@\ȃAhX̏
	memset(&hints, 0, sizeof(hints));
	hints.ai_socktype = SOCK_STREAM;
	hints.ai_flags = AI_PASSIVE;
	DISABLE_C4996
		sprintf(szPort, "%d", wPort);
	ENABLE_C4996

	if (getaddrinfo(NULL, szPort, &hints, &pres) == 0)
	{
		// Ԃpres̒Ɋi[Ăgp
		pTemp = pres;
		while ((pTemp != NULL) && (m_iSockCount < MAX_SOCKET_NUM))
		{
			// Socket̍쐬, bind̎s
			// \Pbg쐬
			m_fdServer[m_iSockCount] = socket(pTemp->ai_family, pTemp->ai_socktype, pTemp->ai_protocol);
			if (m_fdServer[m_iSockCount] == INVALID_SOCKET)
				goto L_NEXT;
			fprintf(stderr, "%d %d %d %d\n", m_fdServer[m_iSockCount], pTemp->ai_family, AF_INET, AF_INET6);
#ifdef IPV6_V6ONLY
			// IPv6\PbgIPv4ˉeAhXgpȂ悤ɐݒ
			if (pTemp->ai_family == AF_INET6)
			{
				on = 1;
				if (setsockopt(m_fdServer[m_iSockCount], IPPROTO_IPV6, IPV6_V6ONLY, (char *)&on, sizeof(on)) < 0)
				{
					fprintf(stderr, "  Err:setsockopt %d\n", errno);
					goto L_NEXT;
				}
			}
#endif
			// N[YɍbindłȂԂ̉
			on = 1;
			setsockopt(m_fdServer[m_iSockCount], SOL_SOCKET, SO_REUSEADDR, (char *)&on, sizeof(on));
			// bind̎s
			if (bind(m_fdServer[m_iSockCount], pTemp->ai_addr, (int)pTemp->ai_addrlen) == SOCKET_ERROR)
			{
				fprintf(stderr, "  Err:bind %d\n", errno);
				DestroySocket(m_fdServer[m_iSockCount]);
				goto L_NEXT;
			}
			++m_iSockCount;
		L_NEXT:
			pTemp = pTemp->ai_next;
		}
		freeaddrinfo(pres);
	}
	if (m_iSockCount == 0)
		fRet = FALSE;
	return(fRet);
}

//----------------------------------------------
// function
//    ҋ@p\Pbgڑ҂Ԃɂ
// parameter
//    Ȃ
// return
//    TRUE/FALSE
//----------------------------------------------
BOOL DoListen()
{
	BOOL		fRet = FALSE;
	int			ii;

	fprintf(stderr, "DoListen()\n");
	for (ii = 0; ii < m_iSockCount; ++ii)
	{
		if (listen(m_fdServer[ii], MAXPENDING) == SOCKET_ERROR)
			continue;
		fRet = TRUE;
	}
	return(fRet);
}

//----------------------------------------------
// function
//    ڑv̎󂯓
// parameter
//    Ȃ
// return
//    TRUE/FALSE
//----------------------------------------------
BOOL DoAccept()
{
	BOOL				fRet = FALSE;
	sockaddr_storage	ClntAddr;	// ڑNCAg̃AhX
	char				szHostAddr[NI_MAXHOST];
	socklen_t			iClntLen;	// ڑNCAg̃AhX̃TCY
	int					ii, iMaxfd = 0;
	fd_set				rfds;
	struct timeval		tv;

	fprintf(stderr, "DoAccept()\n");
	while (1)
	{
		tv.tv_sec = 0;
		tv.tv_usec = 10 * 1000;// 10msec
		FD_ZERO(&rfds);
		for (ii = 0; ii < m_iSockCount; ++ii)
		{
			FD_SET(m_fdServer[ii], &rfds);			// m_fdServer[ii]Ώ
			iMaxfd = max(iMaxfd, m_fdServer[ii]);
		}
		select(iMaxfd + 1, &rfds, NULL, NULL, &tv);
		// L[͂Œf
		if (CheckKey())
		{
			fprintf(stderr, "  OK:Abort by key\n");
			break;
		}
		for (ii = 0; ii < m_iSockCount; ++ii)
		{
			if (FD_ISSET(m_fdServer[ii], &rfds))
			{
				iClntLen = sizeof(ClntAddr);	// ڑAhXi[\̂̃TCY
				if ((m_fdClient = accept(m_fdServer[ii], (sockaddr *)&ClntAddr, &iClntLen)) == INVALID_SOCKET)
				{
					fprintf(stderr, "Err:accept %d\n", errno);
					continue;
				}
				else
				{
					if (getnameinfo((struct sockaddr *) &ClntAddr, (socklen_t)iClntLen,
						szHostAddr, sizeof(szHostAddr), NULL, 0, NI_NUMERICHOST) == 0)
					{
						fprintf(stderr, "%s\n", szHostAddr);
					}
					fRet = TRUE;
					goto L_END;
				}
			}
		}
	}
L_END:
	return(fRet);
}

//----------------------------------------------
// function
//    M
// parameter
//    Ȃ
// return
//    TRUE/FALSE
//----------------------------------------------
BOOL DoRecv()
{
	BOOL		fRet = TRUE;
	char	    szRecvBuffer[RCVBUFSIZE + 1];	// Mobt@
	int			iSize;
	fd_set		rfds;
	struct timeval     tv;

	fprintf(stderr, "DoRecv()\n");
	while (1)
	{
		tv.tv_sec = 0;
		tv.tv_usec = 10 * 1000;							// 10msec
		FD_ZERO(&rfds);
		FD_SET(m_fdClient, &rfds);
		select(m_fdClient + 1, &rfds, NULL, NULL, &tv);	// ^CAEg܂SleepƓ
														// L[͂Œf
		if (CheckKey())
		{
			fprintf(stderr, "  OK:Abort by key\n");
			break;
		}
		if (FD_ISSET(m_fdClient, &rfds))
		{
			memset(szRecvBuffer, 0, sizeof(szRecvBuffer));
			if ((iSize = recv(m_fdClient, szRecvBuffer, RCVBUFSIZE, 0)) <= 0)
			{
				if (iSize == 0)
					fprintf(stderr, "Disconnected %d\n", errno);
				else
					fprintf(stderr, "Err:recv %d\n", errno);
				fRet = FALSE;
				break;
			}
			else
			{
				fprintf(stderr, "%s\n", szRecvBuffer);
			}
		}
	}
	return(fRet);
}


//----------------------------------------------
// function
//    TCP\Pbg̔j
// parameter
//    SOCKET		&fd[in/out]j\Pbg
// return
//    TRUE/FALSE
//----------------------------------------------
BOOL DestroySocket(SOCKET &fd)
{
	fprintf(stderr, "DestroySocket()\n");
	if (fd != INVALID_SOCKET)
	{
		shutdown(fd, SHUT_RDWR);     // MM~
		close(fd);
		fd = INVALID_SOCKET;
	}
	return(TRUE);
}

//----------------------------------------------
// function
//    ؒfA\Pbg̔j
// parameter
//    Ȃ
// return
//    Ȃ
//----------------------------------------------
void Stop()
{
	int		ii;

	fprintf(stderr, "Stop()\n");
	DestroySocket(m_fdClient);
	for (ii = 0; ii < m_iSockCount; ++ii)
		DestroySocket(m_fdServer[ii]);
}

//----------------------------------------------
// function
//    L[̓`FbN
// parameter
//    Ȃ
// return
//    TRUE:͂
//----------------------------------------------
BOOL CheckKey()
{
	BOOL			fRet = FALSE;
	fd_set			rfds;
	struct timeval  tv;
	char			szBuff[81];

	tv.tv_sec = 0;
	tv.tv_usec = 0;
	FD_ZERO(&rfds);						// fd_set̏
										// 0:W 1:Wo 2:WG[
	FD_SET(0, &rfds);					// W͂Ώ
	select(1, &rfds, NULL, NULL, &tv);
	if (FD_ISSET(0, &rfds))				// L[͂
	{
		read(0, szBuff, sizeof(szBuff));
		fRet = TRUE;
	}
	return(fRet);
}
